<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:rss="http://purl.org/rss/1.0/"
  xmlns:atom="http://www.w3.org/2005/Atom"
	>

  <xsl:output method="html" />

  <!-- http://atom.geekhood.net/atom2rss.xsl -->

  <xsl:variable name="crt_idx" select="0"/>
  <xsl:variable name="crt_idx_feed" select="0"/>

  <xsl:template match="/">
        <xsl:apply-templates select="/atom:feed" />
        <xsl:apply-templates select="/rdf:RDF" />
        <xsl:apply-templates select="/rss/channel"/>
  </xsl:template>


  <!--*********************************************************************************************************-->
  <!-- ATOM -->

  <xsl:template match="/atom:feed">
    <!-- ATOM -->
    <div id="feed-main-{$crt_idx_feed}">
      
      <xsl:call-template name="HeaderTable">
        <xsl:with-param name="FeedCaption" select="atom:title" />
        <xsl:with-param name="FeedURL" select = "atom:link/@href"/>
      </xsl:call-template>
      
      <xsl:choose>
        <xsl:when test = '$crt_idx_feed &gt; 0 or $crt_idx="0"'>
          <div id="feed-{$crt_idx_feed}" style="margin-left: 20px; display: none;">
            <xsl:apply-templates select="/atom:feed/atom:entry"/>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <div id="feed-{$crt_idx_feed}" style="margin-left: 20px;">
            <xsl:apply-templates select="/atom:feed/atom:entry"/>
          </div>
        </xsl:otherwise>
      </xsl:choose>

    </div>
  </xsl:template>

  
  <xsl:template match="/atom:feed/atom:entry">
    <div class="FeedCaption">
      <a target="_new" href="{atom:link/@href}"><xsl:value-of select="atom:title"/></a>
    </div>
  </xsl:template>

  <!--*********************************************************************************************************-->
  <!-- RSS 1 -->

  <xsl:template match="/rdf:RDF">
    <div id="feed-main-{$crt_idx_feed}">

      <xsl:call-template name="HeaderTable">
        <xsl:with-param name="FeedCaption" select="rss:channel/rss:title" />
        <xsl:with-param name="FeedURL" select = "rss:channel/rss:link"/>
      </xsl:call-template>
      
      <xsl:choose>
        <xsl:when test = '$crt_idx_feed &gt; 0 or $crt_idx="0"'>
          <div id="feed-{$crt_idx_feed}" style="margin-left: 20px; display: none;">
            <xsl:apply-templates select="/rdf:RDF/rss:item"/>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <div id="feed-{$crt_idx_feed}" style="margin-left: 20px;">
            <xsl:apply-templates select="/rdf:RDF/rss:item"/>
          </div>
        </xsl:otherwise>
      </xsl:choose>

    </div>
  </xsl:template>

  
  <xsl:template match="/rdf:RDF/rss:item">
    <div class="FeedCaption">
      <a target="_new" href="{rss:link}"><xsl:value-of select="rss:title"/></a>
    </div>
    <div class="FeedText">
      <xsl:value-of disable-output-escaping="yes" select="rss:description"/>
    </div>
  </xsl:template>

  <!--*********************************************************************************************************-->
  <!-- RSS 2 -->

  <xsl:template match="/rss/channel">
    <div id="feed-main-{$crt_idx_feed}">

      <xsl:call-template name="HeaderTable">
        <xsl:with-param name="FeedCaption" select="/rss/channel/title" />
        <xsl:with-param name="FeedURL" select = "/rss/channel/link"/>
      </xsl:call-template>      

      <xsl:choose>
        <xsl:when test = '$crt_idx_feed &gt; 0 or $crt_idx="0"'>
          <div id="feed-{$crt_idx_feed}" style="margin-left: 30px; display: none;">
            <xsl:apply-templates select="/rss/channel/item"/>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <div id="feed-{$crt_idx_feed}" style="margin-left: 30px;">
            <xsl:apply-templates select="/rss/channel/item"/>
          </div>
        </xsl:otherwise>
      </xsl:choose>
    </div>

  </xsl:template>

  <xsl:template match="/rss/channel/item" name="feed-item">
    <div class="FeedCaption">
      <a target="_new" href="{link}"><xsl:value-of select="title" /></a>
      
      <div class="FeedText">
        <xsl:value-of disable-output-escaping="yes" select="description"/>
      </div>
      <br/>
    </div>
  </xsl:template>


  <!--***************************************************************************************-->
  <!--***** GENERIC TEMPLATES ***************************************************************-->
  <!--***************************************************************************************-->

  <xsl:template name="HeaderTable">
    <xsl:param name="FeedCaption" />
    <xsl:param name="FeedURL" />

    <table cellpadding="0" cellspacing="0" style="padding: 3px; padding-left: 0px; margin-left: 0px; width: 100%">
    <tr>
      <td width="16" height="16" valign="middle" >
        <xsl:choose>
          <xsl:when test = '$crt_idx_feed &gt; 0 or $crt_idx=0'>
            <img id="collapse-feed-{$crt_idx_feed}" src="chrome://{dtx_application_id}/skin/lib/expand.png" style="margin-right: 5px"/>
          </xsl:when>
          <xsl:otherwise>
            <img id="collapse-feed-{$crt_idx_feed}" src="chrome://{dtx_application_id}/skin/lib/collapse.png" style="margin-right: 5px"/>
          </xsl:otherwise>
        </xsl:choose>
      </td>

      <td width="16" height="16" valign="middle">
        <xsl:if test = '$crt_idx=0'>
          <img src="chrome://{dtx_application_id}/skin/lib/found.png" style="margin-right: 5px"/>
        </xsl:if>
        <xsl:if test = '$crt_idx=1'>
          <img src="chrome://{dtx_application_id}/skin/lib/rss.png" style="margin-right: 5px"/>
        </xsl:if>
        <xsl:if test = '$crt_idx=2'>
          <img src="chrome://{dtx_application_id}/skin/lib/rss.png" style="margin-right: 5px"/>
        </xsl:if>
      </td>

      <td height="16" >
        <xsl:value-of disable-output-escaping="yes" select="$FeedCaption" />
      </td>

      <td style="padding-left: 10px" align="right">
        
        <xsl:if test = '$crt_idx=0'>
            <button id="feed-subscribe-{$crt_idx_feed}" feedIdx="{$crt_idx_feed}" feedURL="{$FeedURL}" style="padding: 0px; float: right;" tabindex="0">
            <table cellpadding="0" cellspacing="0" style="padding: 0px; margin: 0px">
              <tr>
                <td valign="middle" align="right">
                  <img style="margin-right: 3px" src="chrome://{dtx_application_id}/skin/lib/add.png"/>
                </td>
                <td valign="middle">
                  <div style="font: 9pt Tahoma; margin-left: 5px; cursor: default">Subscribe</div>
                </td>
              </tr>
            </table>
            </button>
        </xsl:if>

        <xsl:if test = '$crt_idx=1'>
          <img width="16" height="16" src="chrome://{dtx_application_id}/skin/lib/lock.png" align="right"/>
        </xsl:if>

        <xsl:if test = '$crt_idx=2'>
          <img id="feed-modify-{$crt_idx_feed}" feedIdx="{$crt_idx_feed}" feedURL="{$FeedURL}" align="right" src="chrome://{dtx_application_id}/skin/lib/remove.png" style="cursor: hand" />
        </xsl:if>
      </td>
    </tr>
    </table>

  </xsl:template>

</xsl:stylesheet>
