// Process the Manifest
var external = manifest.getElementsByTagName("externalManifest");
if (external.length == 0)
	return;

external = external[0];

if(external.firstChild == null)
	return;


external = framework.loadXML(external.firstChild.nodeValue);


// Check if you can install the widget
if(framework.compareFrameworkVersion(framework.getVersion(), getExternalManifestValue("fw_version")) < 0) {
	alert("You toolbar will not support this app.  Please upgrade your toolbar.");
	return;
}

// Get some general values.
var widgetTitle		= manifest.getAttribute("name");
var widgetDesc		= getExternalManifestValue("description");
var panel			= null;

var addButton		= true;
var	iconimage		= getExternalManifestValue("buttonIcon") || "tb_icon.png";
var imagePath		= framework.makeChromeURL('content/widgets/' + manifest.getAttribute("id") + '/' + iconimage);

var widgetPath		= framework.makeChromeURL('content/widgets/' + manifest.getAttribute("id") + '/');

function setMutiAttr(o, h) {
	for(var i in h) { o.setAttribute(i, h[i]); }
}

// Create the Button
var sWigetID = "vmn_widget_button_" + framework.applicationId + manifest.getAttribute("id");

if(framework.mainContainer.getElementById(sWigetID) != null) {
	var button = framework.getElementById(sWigetID);
	addButton = false;
} else {
	var button = framework.createElement("toolbarbutton");
	setMutiAttr(button, {
		"id":			sWigetID, 
		"persist":		"image index hidden", 
		"label":		widgetTitle,
		"type":			"button", 
		"tooltiptext":	widgetDesc,
		"optional":		"true",
		"title":		widgetTitle,
		"track":		"true", 
		"statID":		"widget-" + widgetTitle, 
		"image":		imagePath,
		"imageheight":	"16",
		"imagewidth":	"16"
	});
}

this.serialize = true;
this.buttonId  = button;

if(dtxFramework.MOZILLA && parseInt(framework.getBrowserVersion()) >= 4){
	var self = this;
	this.$remoteHost = framework.extractHost(getExternalManifestValue('remoteurl'));
	this.$permissionManager = Components.classes["@mozilla.org/permissionmanager;1"].getService(Components.interfaces.nsIPermissionManager);
	this.$ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	
	this.$isRemoteXulEnabled = function(){
		var enumerator = this.$permissionManager.enumerator;
		while (enumerator.hasMoreElements()) {
			permission = enumerator.getNext().QueryInterface(Ci.nsIPermission);
			if(permission.host == this.$remoteHost) return true;
		}
		
		return false;
	};

	this.$enableRemoteXul = function(){
		this.$permissionManager.add(this.$ioService.newURI("http://"+this.$remoteHost, null, null), "allowXULXBL", 1);
	};

	this.$disableRemoteXul = function(){
		this.$permissionManager.remove(this.$remoteHost, "allowXULXBL");
	};

	framework.addEventListener(this,"quit",function(){
		self.$disableRemoteXul();
	});

	this.$enableRemoteXul();
}

// When the widget button is clicked, we make the panel and set up the contents.
button.addEventListener("command", function(evt) {
	var target = evt.target;
	var callerid = null;
	if(framework.mainContainer.getAttribute("toolbarname"))
		var callerid = 'Widget'+'-'+manifest.getAttribute("id")+'-'+framework.applicationId+'-'+framework.mainContainer.getAttribute("version");

	// Create the Panel
	if(dtxFramework.MOZILLA && parseInt(framework.getBrowserVersion()) >= 4 && !self.$isRemoteXulEnabled()){
		self.$enableRemoteXul();
	}

	if(panel == null) 
	{
		
				// Create the Panel
				try {
					panel = framework.createElement('panel');
					var PanelWidth = getExternalManifestValue("width");
					var PanelHeight = getExternalManifestValue("height");
					var templatePath = "content/widgets/"+manifest.getAttribute("id")+"/skin";
					var showAds	= getExternalManifestValue("show_ads");

				
					setMutiAttr(panel, {
						'drag': 'true',
						'ontop': 'false',
						'autohide': 'false',
						'dependent': 'true', 
						'doresize': 'false', 
						'title': widgetTitle
					});

					panel.setTemplate(templatePath, PanelWidth, PanelHeight);
					panel.setThumbnailImg(imagePath);
					panel.setTransparentColor("#FF00FF");

					panel.addEventListener('close', function(event) {  
						panel.panel = null;
					});

					panel.addEventListener("beforeshowing", function(evt) {
						var target = evt.target;
						
						if(dtxFramework.IE) var dtxObj = framework.createElement("iframe");
						else var dtxObj = framework.createElement("iframe");

						setMutiAttr(dtxObj, {
							"id": "container_frame",
							"width": (getExternalManifestValue("width") - 18) + "",
							"height": (getExternalManifestValue("height") - 29) + "",
							"frameborder": "0",
							"scrolling": "no",
							"style": "overflow: hidden"
						});

						target.appendChild(dtxObj);
					});

					panel.addEventListener("aftershowing", function(evt) {
						
							panel.$window.document.getElementById('CloseBtn').onclick = function(){panel = null;};
						
							if(dtxFramework.IE) var dtxObj = framework.getElementById("container_frame");
							else var dtxObj = framework.getElementById("container_frame");
									
							var oScript = null;

							var sWidgetPath = framework.makeChromeURL('content/widgets/' + manifest.getAttribute("id") + '/' +  getExternalManifestValue("publicUrl"));

							if(dtxFramework.IE) {
								o = dtxObj.$domNode.document.Script;
							} else {
								dtxObj.setAttribute("src", sWidgetPath);
								o = dtxObj.$domNode.contentWindow.top;
							}

							o.panel = panel;		// Don't know how to retrieve this instance from inside.
							o.apiUrl				= getExternalManifestValue('api_url');
							o.dtxFramework			= dtxFramework;
							o.framework				= framework;
							o.widgetPath			= widgetPath;
							o.iconImage				= imagePath;
							o.callerId				= callerid;
							o.templatePath			= templatePath;
							o.showAds				= showAds;
							o.widgetId				= manifest.getAttribute("id");
							o.manifest				= manifest;
							o.remoteurl				= getExternalManifestValue('remoteurl');

							if(dtxFramework.IE) {
								dtxObj.setAttribute("src", sWidgetPath);
							}
							
					});
					
					panel.showRelative(button, 0, 25);
					panel.focus();
				}
				catch(e) {
					alert(e.message);
				}
		}
		else
			panel.focus();

});

if(addButton) {
	framework.mainContainer.appendChild(button);
}

// Function to get a value from the manifest file.
function getExternalManifestValue(id) {
	var node = external.getElementsByTagName(id);
	if (node.length == 0)
		return "";
	else if (node[0].firstChild == null)
		return "";
	else
		return node[0].firstChild.nodeValue;
}
//Count FB Requests/Messages/Notifications -->

var num_of_fb_notifications = 0;

function refreshButton(num_of_fb_notifications){
	
	if(num_of_fb_notifications > 0)
	{	
		button.setAttribute('label', widgetTitle + " (" + num_of_fb_notifications + ")");
	}
	else
	{
		button.setAttribute('label', widgetTitle);
	}
};

framework.setInterval(

		function() {
			updateCount();
		}, 15 * 1000 // perform every XX seconds

	);

function updateCount(){
	var access_token = framework.hasDomainCookie(getExternalManifestValue('remoteurl'),'accss_tkn_msfb');
	if (access_token != null)
		num_of_fb_notifications = getCount(access_token);
	else
		num_of_fb_notifications = 0;

	refreshButton(num_of_fb_notifications);
}

function getCount(access_token) {
	var totalOfCounts = 0;

	var urlToPost = 'https://api.facebook.com/method/fql.query';

	var query = [
             		'SELECT notification_id FROM notification WHERE recipient_id = me() AND is_unread != 0', // get unread notifications
             		'SELECT unread FROM thread WHERE folder_id = 0 AND unread != 0', // get threads that contain unread messages
             		'SELECT uid_from FROM friend_request WHERE uid_to = me()' // get friends requests to user
	             ];

	var data = '&access_token=' + access_token + '&format=json&query=' + encodeURIComponent(query[0]);
	req = framework.createHTTPRequest(urlToPost, "POST", false);
	req.setRequestHeader('Content-Type', "application/x-www-form-urlencoded");
	req.onreadystatechange = function(evt)
	{
		if(req.readyState == 4)//Completed
		{
			if(req.status >= 200 && req.status <= 300)
			{
				if(req.responseText != '')
				{
					var myObject = eval('(' + req.responseText + ')');
					totalOfCounts += myObject.length;
				}
			}
		}
	};
	req.send(data);
			
	var data = '&access_token=' + access_token + '&format=json&query=' + encodeURIComponent(query[1]);
	req = framework.createHTTPRequest(urlToPost, "POST", false);
	req.setRequestHeader('Content-Type', "application/x-www-form-urlencoded");
	req.onreadystatechange = function(evt)
	{
		if(req.readyState == 4)//Completed
		{
			if(req.status >= 200 && req.status <= 300)
			{
				if(req.responseText != '')
				{
					var myObject = eval('(' + req.responseText + ')');
							for(var i=0; i<myObject.length; i++) {
								totalOfCounts += parseInt(myObject[i].unread);
							}
				}
			}
		}
	};
	req.send(data);
	
	var data = '&access_token=' + access_token + '&format=json&query=' + encodeURIComponent(query[2]);
	req = framework.createHTTPRequest(urlToPost, "POST", false);
	req.setRequestHeader('Content-Type', "application/x-www-form-urlencoded");
	req.onreadystatechange = function(evt)
	{
		if(req.readyState == 4)//Completed
		{
			if(req.status >= 200 && req.status <= 300)
			{
				if(req.responseText != '')
				{
					var myObject = eval('(' + req.responseText + ')');
					totalOfCounts += myObject.length;
				}
			}
		}
	};
	req.send(data);

	return totalOfCounts;
}



/**
 * Implements JSON stringify and parse functions
 * v1.0
 *
 * By Craig Buckler, Optimalworks.net
 *
 * As featured on SitePoint.com
 * Please use as you wish at your own risk.
*
 * Usage:
 *
 * // serialize a JavaScript object to a JSON string
 * var str = JSON.stringify(object);
 *
 * // de-serialize a JSON string to a JavaScript object
 * var obj = JSON.parse(str);
 */

var JSON = JSON || {};

// implement JSON.stringify serialization
JSON.stringify = JSON.stringify || function (obj) {

	var t = typeof (obj);
	if (t != "object" || obj === null) {

		// simple data type
		if (t == "string") obj = '"'+obj+'"';
		return String(obj);

	}
	else {

		// recurse array or object
		var n, v, json = [], arr = (obj && obj.constructor == Array);

		for (n in obj) {
			v = obj[n]; t = typeof(v);

			if (t == "string") v = '"'+v+'"';
			else if (t == "object" && v !== null) v = JSON.stringify(v);

			json.push((arr ? "" : '"' + n + '":') + String(v));
		}

		return (arr ? "[" : "{") + String(json) + (arr ? "]" : "}");
	}
};


// implement JSON.parse de-serialization
JSON.parse = JSON.parse || function (str) {
	if (str === "") str = '""';
	eval("var p=" + str + ";");
	return p;
};







