var locationX = 500;
var locationX = 500;
var locationY = 200;
var MAX_RESULTS = 50;
var TITLE_SIZE	= 25;
var DESC_SIZE	= 70;

if (typeof console == "object")
    log = console.log;
else
    log = function()
    {
    };

function addCommas(nStr)
{
    nStr += '';
    x = nStr.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? '.' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1))
    {
        x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }
    return x1 + x2;
}

function urlencode(str)
{
    str = (str + '').toString();
    return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27')
            .replace(/\(/g, '%28').replace(/\)/g, '%29').replace(/\*/g, '%2A')
            .replace(/%20/g, '+');
}

function humane_date(date_str)
{
    date_str = date_str.replace('.000', '');
    var time_formats = [ [ 60, 'Just Now' ], [ 90, '1 Minute' ],
            [ 3600, 'Minutes', 60 ], [ 5400, '1 Hour' ],
            [ 86400, 'Hours', 3600 ], [ 129600, '1 Day' ],
            [ 604800, 'Days', 86400 ], [ 907200, '1 Week' ],
            [ 2628000, 'Weeks', 604800 ], [ 3942000, '1 Month' ],
            [ 31536000, 'Months', 2628000 ], [ 47304000, '1 Year' ],
            [ 3153600000, 'Years', 31536000 ], [ 4730400000, '1 Century' ], ];
    var time = ('' + date_str).replace(/-/g, "/").replace(/[TZ]/g, " "), dt = new Date, seconds = ((dt
            - new Date(time) + (dt.getTimezoneOffset() * 60000)) / 1000), token = ' Ago', i = 0, format;
    if (seconds < 0)
    {
        seconds = Math.abs(seconds);
        token = '';
    }

    while (format = time_formats[i++])
    {
        if (seconds < format[0])
        {
            if (format.length == 2)
            {
                return format[1] + (i > 1 ? token : ''); // Conditional so we
                                                            // don't return Just
                                                            // Now Ago
            } else
            {
                return Math.round(seconds / format[2]) + ' ' + format[1]
                        + (i > 1 ? token : '');
            }
        }
    }

    // overflow for centuries
    if (seconds > 4730400000)
        return Math.round(seconds / 4730400000) + ' Centuries' + token;

    return date_str;
};

function depaginate()
{
	$('#contents').depagination();
}

function loadFeed(urltosend, tabid)
{
	currentPage = 1;
	var orderBy = $('#OrderBy').val();
    var time = $('#Uploaded').val();
    $('#contents').unbind();
    $('#tab_ul').children().removeClass("current");
    $('#' + tabid).addClass("current");
    $('#contents').empty();
    $('#stats').empty();
    $('#stats1').empty();
  
    $('#contents').html('<center><img src="images/throbber.gif" style="margin-top:200px;" /></center>');
    $.getJSON(urltosend + '&callback=?',
        function(jsondata)
        {
            var yt_total_result = jsondata.feed.openSearch$totalResults.$t;
            var yt_start_index = jsondata.feed.openSearch$startIndex.$t;
            var yt_items_per_page = jsondata.feed.openSearch$itemsPerPage.$t;
            var yt_end_index = "";
        
			
			
            // Put the stats in
            
			if (tabid == 0)
				
                $('#stats1')
                        .html();
			
			
			if (currentPage <=1){
							yt_start_index = 1;
							if (yt_total_result == '0') yt_start_index = 0;
							yt_end_index	=	yt_start_index + 7;
							yt_end_index	=	Math.min(yt_end_index,Math.min(yt_total_result,MAX_RESULTS));
						}
			else {
							yt_start_index = (currentPage - 1)*8+1;
							yt_end_index	=	yt_start_index + 7;
							yt_end_index	=	Math.min(yt_end_index,Math.min(yt_total_result,MAX_RESULTS));
						}
			
			 $('#stats1').html(
											'<b>'+yt_start_index
											+ '</b> to <b>' + yt_end_index
											+ '</b> of <b>'
											+ addCommas(Math.min(yt_total_result,MAX_RESULTS))
											+ '</b>');
						
            if (tabid == 0)
            {
                $('#stats').html($('#statsX').html());
                // pre-select filter values
                $('#OrderBy').val(orderBy);
                $('#Uploaded').val(time);
            }
            $('#contents').empty();
			
			
            if (yt_total_result != 0)
            {
                $
                        .each(
                                jsondata.feed.entry,
                                function(i, oneEntry)
                                {
                                    var yt_vidid = oneEntry.media$group.yt$videoid.$t;
                                    var yt_title = oneEntry.title.$t;
                                    var yt_thumbnail = oneEntry.media$group.media$thumbnail[0].url;
                                    var yt_duration = oneEntry.media$group.media$content[0].duration;
                                    var yt_url = oneEntry.media$group.media$content[0].url;
                                    var yt_uploaded = oneEntry.media$group.yt$uploaded.$t;
                                    if (oneEntry.yt$statistics)
                                        var yt_views = oneEntry.yt$statistics.viewCount;
                                    else
                                        var yt_views = 0;
                                    var yt_keywords = oneEntry.media$group.media$keywords.$t;
                                    var yt_description = oneEntry.media$group.media$description.$t;
                                    var yt_to_send = 'url='
                                            + escape(yt_url)
                                            + '&title='
                                            + escape(yt_title)
                                            + '&keywords='
                                            + escape(yt_keywords)
                                            + '&desc='
                                            + escape(yt_description.substr(0, DESC_SIZE));

                                    if (String(yt_duration % 60).length == 1)
                                        if (yt_duration % 60 < 10)
                                            var sec = '0'
                                                    + yt_duration
                                                    % 60;
                                        else
                                            var sec = yt_duration
                                                    % 60 + '0';
                                    else
                                        var sec = yt_duration % 60;

                                    var duration = Math
                                            .floor(yt_duration / 60)
                                            + ':' + sec;
									if (yt_title.length > TITLE_SIZE) yt_title = yt_title.substr(0, TITLE_SIZE)+'...';
									else yt_title = yt_title.substr(0, TITLE_SIZE);
									
                                    $('<div class="video"></div>')
                                            .html(
															'<div class="thumb_border"><div class="thumb" style="background-image: url('+yt_thumbnail+');"><div class="duration_format">'+duration+'</div></div></div>'
															+ '<div class="title_format"><b>'+yt_title+'</b></div>'
															+ '<div class="upload_time">'
                                                            + humane_date(yt_uploaded)
                                                            + '</div>'
                                                            + '<div>'
															+ addCommas(yt_views)
															+ ' Views'+
															'</div>'
														
												)
                                            .bind('click',
                                                    yt_to_send,
                                                    openPanel)
                                            
											
											.hover(
                                                    function()
                                                    {
                                                        $(this)
                                                                .addClass(
                                                                        'hover');
                                                    },
                                                    function()
                                                    {
                                                        $(this)
                                                                .removeClass(
                                                                        'hover')
                                                    })
											
											.appendTo(
                                                    '#contents'
													);
													
                                });
								
								$('#contents').pagination();
								
								
								
								
								
            }
        });
		
		$('#contents').depagination();
		
    
		
}

function openPanel(e)
{
	if (top.framework == "null") return;
    var panel = top.framework.createElement("panel");
    var framework = top.framework;
    var panel = framework.createElement('panel');
    var widgetTitle = "YouTube";
    var widgetPath = top.widgetPath;
    var iconImage = top.iconImage;
    var callerID = top.callerId;
    var template = top.templatePath;
    var showAds = top.showAds;

    if (showAds == "true")
        var panelHeight = 582;
    else
        var panelHeight = 452;

    panel.setAttribute("width", "300");
    panel.setAttribute("drag", "true");
    panel.setAttribute("ontop", "false");
    panel.setAttribute("autohide", "false");
    panel.setAttribute("dependent", "true");
    panel.setAttribute("doresize", "false");
    panel.setAttribute("title", widgetTitle);
    panel.setTemplate(template, 514, panelHeight);
    panel.setThumbnailImg(iconImage);
    panel.setTransparentColor("#FF00FF");

    panel.addEventListener("beforeshowing", function(evt)
    {
        var target = evt.target;
        var dtxObj = framework.createElement("iframe");

        dtxObj.setAttribute("id", "container_frame");
        dtxObj.setAttribute("width", 495 + "");
        dtxObj.setAttribute("height", 550 + "");
        dtxObj.setAttribute("frameborder", "0");
        dtxObj.setAttribute("scrolling", "no");
        dtxObj.setAttribute("style", "overflow:hidden;");
        target.appendChild(dtxObj);
    });

    panel.addEventListener("aftershowing", function(evt)
    {
        panel.$window.document.getElementById('CloseBtn').onclick = function(){self.close();self.focus();};
		var dtxObj = framework.getElementById("container_frame");
        var params = e.data + "&callerId=" + callerID + "&showAds=" + showAds;
        dtxObj.setAttribute("src",
                "http://apps.mystart.com/data/widgets/youtube2/html/videoplayer.php?"
                        + params);
    });

    panel.show(locationX, locationY);
    panel.focus();

    locationX += 20;
    locationY += 20;
}

function updateInterface()
{
    // do nothing
}

$(document)
        .ready(
				
                function()
                {
									
									
					var loadUrl = 'http://gdata.youtube.com/feeds/api/standardfeeds/most_viewed?v=2&alt=json&time=today&format=5&max-results='
                            + MAX_RESULTS;
					
					$('#contents').pagination();
					
					loadFeed(loadUrl, 'tab_viewed');
					
					
					$("div .paginator A").live("click", function(e){
						
						if (currentPage <=1){
							yt_start_index = 1;
							yt_end_index	=	yt_start_index + 7;
							yt_end_index	=	Math.min(yt_end_index,allItems);
						}
						else {
							yt_start_index = (currentPage - 1)*8+1;
							yt_end_index	=	yt_start_index + 7;
							yt_end_index	=	Math.min(yt_end_index,allItems);
						}
						
						$('#stats1').html(
								'<b>'+yt_start_index
                                + '</b> to <b>' + yt_end_index
                                + '</b> of <b>'
                                + addCommas(allItems)
                                + '</b>');
					
					}); 
					
					
                    var bSkipEvent = false;
					
					separator = ''; // To separate paginator's items
					paginatorPosition = 'bottom'; // where you want the paginator to be. Accepted values are 'top','bottom','both'
					paginatorStyle = 3; // To define which style of paginator you need.
					enablePageOfOption = false; // it shows on which are you currently, i.e. Page 3 of 6 , if turned true
					enableGoToPage = false; // shows a drop down of all pages for go/jump to any page user want to go, if turned true. Useful incase there are large no. of pages
					enableSelectNoItems = false; // if you want to change items per page on the fly.
					itemsPerPage	=	8;
					prev_show_always	=	false;
					next_show_always	=	false;
					
					$( "#box" ).autocomplete({
							source: function( request, response ) {
								
								url = "http://suggestqueries.google.com/complete/search?hl=en&ds=yt&json=t&q=" + request.term;
								$.getJSON(url + '&callback=?', function(data) {
									keywords = $('#box').val();
									
									for(i=0;i<data[1].length;i++)
									{
										data[1][i]=data[1][i].replace(new RegExp("("+keywords+")", "gi"),'<b>$1</b>');
										
									}
									
									response(data[1]);
								});
							},
							minLength: 1,
							focus: function(event, ui) {
								ui.item.value = ui.item.value.replace('<b>', '');
								ui.item.value = ui.item.value.replace('</b>', '');
							}
							
					});
					
					if (! $.browser.msie ) {
						$( "#box" ).bind("autocompleteselect",doSearch);
					}
					
				
                });

function doSearch()
{
    var searchVal = $('#box').val();
    var orderBy = $('#OrderBy').val();
    var time = $('#Uploaded').val();
	$('#contents').depagination();
	$('#stats1').html();
	currentPage = 1;
    loadFeed(
            'http://gdata.youtube.com/feeds/api/videos?v=2&alt=json&format=5&max-results='+MAX_RESULTS+'&orderby='
                    + orderBy + '&time=' + time + '&q=' + escape(searchVal), 0);
	$('.ui-autocomplete').hide();
}



