// Process the Manifest
var vexternal = manifest.getElementsByTagName("externalManifest");
if (vexternal.length == 0)
	return;
vexternal = vexternal[0];

if(vexternal.firstChild == null)
	return;
vexternal = framework.loadXML(vexternal.firstChild.nodeValue);


// Check if you can install the widget
if(framework.compareFrameworkVersion(framework.getVersion(), getExternalManifestValue("fw_version")) < 0) {
	alert("You toolbar will not support this app.  Please upgrade your toolbar.");
	return;
}

// Get some general values.
var widgetTitle		= manifest.getAttribute("name");
var widgetDesc		= getExternalManifestValue("description");
var panel			= null;

var addButton		= true;
var	iconimage = getExternalManifestValue("buttonIcon") || "tb_icon.png";
var imagePath		= framework.makeChromeURL('content/widgets/' + manifest.getAttribute("id") + '/' + iconimage);

var widgetPath		= framework.makeChromeURL('content/widgets/' + manifest.getAttribute("id") + '/');


// Create the Button
if(framework.mainContainer.getElementById("vmn_widget_button_" + framework.applicationId + manifest.getAttribute("id")) != null) {
		var button = framework.getElementById("vmn_widget_button_" + framework.applicationId + manifest.getAttribute("id"));
		addButton = false;
} else {
		var button = framework.createElement("toolbarbutton");
		button.setAttribute("id",			"vmn_widget_button_" + framework.applicationId + manifest.getAttribute("id"));
		button.setAttribute("persist",		"image index hidden");
		button.setAttribute("label",		widgetTitle);
		button.setAttribute("type",			"button");
		button.setAttribute("tooltiptext",	widgetDesc);
		button.setAttribute("optional",		"true");
		button.setAttribute("title",		widgetTitle);
		button.setAttribute("track",		"true");
		button.setAttribute("statID",		"widget-" + widgetTitle);
		button.setAttribute("image",		imagePath);
		button.setAttribute("imageheight",	"16");
		button.setAttribute("imagewidth",	"16");
}

//var self = eval(framework.applicationId);

this.serialize = true;
this.buttonId  = button;

// When the widget button is clicked, we make the panel and set up the contents.
button.addEventListener("command",

	function(evt) {
		var target = evt.target;
		var callerid = null;
		if(framework.mainContainer.getAttribute("toolbarname"))
			var callerid = 'Widget'+'-'+manifest.getAttribute("id")+'-'+framework.applicationId+'-'+framework.mainContainer.getAttribute("version");
		
		// Create the Panel
		if(panel == null) 
		{
			
			try {
				
				var asBtn		= button;
				panel		= framework.createElement('panel');
				var PanelWidth	= getExternalManifestValue("width");
				var PanelHeight = getExternalManifestValue("height");
				var templatePath= "content/widgets/"+manifest.getAttribute("id")+"/skin";
				var showAds		= getExternalManifestValue("show_ads");

				panel.setAttribute('drag',		'true');
				panel.setAttribute('ontop',		'false');
				panel.setAttribute('autohide',	'false');
				panel.setAttribute('dependent', 'true'); 
				panel.setAttribute('doresize',	'false'); 
				panel.setAttribute('title',		widgetTitle);
				
				panel.setTemplate(templatePath, PanelWidth, PanelHeight);
				panel.setThumbnailImg(imagePath);
				panel.setTransparentColor("#FF00FF");
							
				panel.addEventListener("beforeshowing", function(evt) {
					
					var target = evt.target;
					
					if(dtxFramework.IE) var dtxObj = framework.createElement("iframe");
					else var dtxObj = framework.createElement("iframe");
					

					dtxObj.setAttribute("id",			"container_frame");
					dtxObj.setAttribute("width",		567 + "");
					dtxObj.setAttribute("height",		505 + "");
					dtxObj.setAttribute("frameborder",	"0");
					dtxObj.setAttribute("scrolling",	"no");
					dtxObj.setAttribute("style",		"overflow: hidden");
					target.appendChild(dtxObj);
					
				});

				panel.addEventListener("aftershowing", function(evt){
					
					panel.$window.document.getElementById('CloseBtn').onclick = function(){panel = null;};
					
					if(dtxFramework.IE) var dtxObj = framework.getElementById("container_frame");
					else var dtxObj = framework.getElementById("container_frame");
										
					dtxObj.setAttribute("src", framework.makeChromeURL('content/widgets/' + manifest.getAttribute("id") + '/' +  getExternalManifestValue("publicUrl")));
									

					if(dtxFramework.IE) {
						
						dtxObj.$domNode.document.Script.framework	= framework;
						dtxObj.$domNode.document.Script.widgetPath	= widgetPath;
						dtxObj.$domNode.document.Script.iconImage	= imagePath;
						dtxObj.$domNode.document.Script.callerId	= callerid;
						dtxObj.$domNode.document.Script.templatePath= templatePath;
						dtxObj.$domNode.document.Script.showAds		= showAds;
					
					}
					else {
						dtxObj.$domNode.contentWindow.top.framework		= framework;
						dtxObj.$domNode.contentWindow.top.widgetPath	= widgetPath;
						dtxObj.$domNode.contentWindow.top.iconImage		= imagePath;
						dtxObj.$domNode.contentWindow.top.callerId		= callerid;
						dtxObj.$domNode.contentWindow.top.templatePath	= templatePath;
						dtxObj.$domNode.contentWindow.top.showAds		= showAds;
					}
					
				});
				//panel.addEventListener("close", function() {panel = null;});
				
				panel.showRelative(asBtn, 0, 25);
				panel.focus();
			}
			catch(e)
			{
				alert(e.message);
			}
		}
		else
			panel.focus();

});

if(addButton){
	framework.mainContainer.appendChild(button);
}


// Function to get a value from the manifest file.
function getExternalManifestValue(id) {
	var node = vexternal.getElementsByTagName(id);
	if (node.length == 0)
		return "";
	else if (node[0].firstChild == null)
		return "";
	else
		return node[0].firstChild.nodeValue;
}

