<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" />

  <xsl:param name="applicationId" />

  <xsl:template match="/">
    <menupopup id="{$applicationId}-search-popup-xsl">
      <menu id="{$applicationId}-search-Web Search-engine-popup-item" label="Web Search" class="menu-iconic" image="chrome://{$applicationId}/skin/web.png" tooltiptext="Web Search">
        <menupopup>
          <xsl:for-each select="engines/OpenSearchDescription">
            <xsl:if test="Description='Web Search'">
              <menuitem id="{$applicationId}-search-{EngineId}" dtx-engine-id="search{position()}"
              label="{ShortName}"
                    tooltiptext="{Description}"
                oncommand="this.target.framework.namespace.engineSelect('search{position()}', '{$applicationId}-search-search0-engine-popup-item', 'true')"
              type="radio"
	      isengineitem="true"
              class="{$applicationId}-search-engines"
              name="{$applicationId}-web"/>
            </xsl:if>
          </xsl:for-each>
        </menupopup>
      </menu>

      <xsl:for-each select="engines/OpenSearchDescription">
        <xsl:if test="Description!='Web Search'">
          <menuitem id="{$applicationId}-{EngineId}" dtx-engine-id="search{position()}"
                  label="  {ShortName}"
                  class="vmn-menuitem"
                  image="{Image}"
                  tooltiptext="{Description}"
                  oncommand="this.target.framework.namespace.engineSelect('search{position()}', '{$applicationId}-{EngineId}', 'true')"
                  name="{$applicationId}-web"/>
        </xsl:if>
      </xsl:for-each>
      <menuseparator index="300" />
      <menuitem label="  Clear Search History" oncommand="this.target.framework.namespace.clearHistory();" tooltiptext="Clear History" index="301"/>
 
    </menupopup>
  </xsl:template>
</xsl:stylesheet>



