<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" />

<xsl:template match="games">
	<xsl:variable name="startAt"><xsl:value-of select="@start" /></xsl:variable>
	<xsl:for-each select="game">
		<xsl:if test="(position() + $startAt) mod 5 = 1 and (position() + $startAt) != 1">
			<br style="clear:both"/>
		</xsl:if>
		
		<a id="id_div_Content_{position() + $startAt}" class="gamelisting_game" style="cursor:pointer" href="#" onclick="GameOnClick('{position() + $startAt}'); return false;" 
			ondblclick="GameOnDoubleClick('{position() + $startAt}'); return false;">
			<table cellspacing="0" border="0" width="70" height="85">
				<tr width="100%" valign="bottom" align="center">
					<td height="53px">
						<img id="id_Content_Img_{position() + $startAt}" src="{IconLocation/text()}" style="width:60px; height:50px; border:0px; xmargin-top:2px; xmargin-left:2px;" />
					</td>
				</tr>
				<tr>
					<td width="68px" height="30px" align="center" valign="top">
						<div id="id_Content_title_{position() + $startAt}" class="gamelisting_game_title"><xsl:value-of select="GameDisplayTitle/text()" /></div>
						<div id="id_gameType_{position() + $startAt}" style="display:none;"><xsl:value-of select="@gametypeid" /></div>
						<div id="id_categoryType_{position() + $startAt}" style="display:none;"><xsl:value-of select="@categoryid" /></div>
						<xsl:choose>
							<xsl:when  test= "GameDescription != ''">
								<div id="id_Content_description_{position() + $startAt}" style="display:none;"><xsl:value-of select="GameDescription/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Content_description_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "SystemRequirements != ''">
								<pre id="id_SystemRequirements_{position() + $startAt}" style="display: none;"><xsl:value-of select="SystemRequirements/text()" /></pre>
							</xsl:when>
							<xsl:otherwise>
								<pre id="id_SystemRequirements_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></pre>
							</xsl:otherwise>
						</xsl:choose>											
						<xsl:choose>
							<xsl:when test= "TryLink[.!='']">
								<div id="id_Trylink_{position() + $startAt}" style="display: none;"><xsl:value-of select="TryLink/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Trylink_{position() + $startAt}" style="display: none;"><xsl:text >0</xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "BuyLink != ''">
								<div id="id_Buylink_{position() + $startAt}" style="display: none;"> <xsl:value-of select="BuyLink/text()"/> </div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Buylink_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "GameLocation != ''">
								<div id="id_Content_swf_{position() + $startAt}" style="display: none;"><xsl:value-of select="GameLocation/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Content_swf_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "PanelWidth != ''">
								<div id="id_width_swf_{position() + $startAt}" style="display: none;"><xsl:value-of select="PanelWidth/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_width_swf_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "PanelHeight != ''">
								<div id="id_hight_swf_{position() + $startAt}" style="display: none;"><xsl:value-of select="PanelHeight/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_hight_swf_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "FeedFrom != ''">
								<div id="id_Feedfrom_{position() + $startAt}" style="display: none;"><xsl:value-of select="FeedFrom/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Feedfrom_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "FileSize != ''">
								<div id="id_FileSize_{position() + $startAt}" style="display: none;"><xsl:value-of select="FileSize/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_FileSize_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "Price != ''">
								<div id="id_Price_{position() + $startAt}" style="display: none;"><xsl:value-of select="Price/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Price_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "Currency != ''">
								<div id="id_Currency_{position() + $startAt}" style="display: none;"><xsl:value-of select="Currency/text()" /></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Currency_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "NumberOfDownloads != ''">
								<div id="id_NumberOfDownloads_{position() + $startAt}" style="display: none;"><xsl:value-of select="NumberOfDownloads/text()"/></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_NumberOfDownloads_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "Rating != ''">
								<div id="id_Rating_{position() + $startAt}" style="display: none;"><xsl:value-of select="Rating/text()"/></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_Rating_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "DateAdded != ''">
								<div id="id_DateAdded_{position() + $startAt}" style="display: none;"><xsl:value-of select="DateAdded/text()"/></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_DateAdded_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "GameLanguage != ''">
								<div id="id_GameLanguage_{position() + $startAt}" style="display: none;"><xsl:value-of select="GameLanguage/text()"/></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_GameLanguage_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when  test= "ExternalID != ''">
								<div id="id_ExternalID_{position() + $startAt}" style="display: none;"><xsl:value-of select="ExternalID/text()"/></div>
							</xsl:when>
							<xsl:otherwise>
								<div id="id_ExternalID_{position() + $startAt}" style="display: none;"><xsl:text> </xsl:text></div>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
			</table>
		</a>
		
	</xsl:for-each> 
	
	</xsl:template>

</xsl:stylesheet>
